SoCube(3)

NAME
SoCube - The SoCube class is for rendering cubes.

SYNOPSIS

#include <Inventor/nodes/SoCube.h>

Inherits SoShape.

  Public Member Functions
virtual SoType getTypeId (void) const
SoCube (void)
virtual void GLRender (SoGLRenderAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFFloat width
SoSFFloat height
SoSFFloat depth

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoCube ()
virtual void generatePrimitives (SoAction *action)
virtual void computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoCube class is for rendering cubes. Insert a cube shape into the scene graph. The cube is rendered with the current material, texture and draw style settings (if any, otherwise the default settings are used).

(Strictly speaking, as you can have different width, height and depth values for the 'cube', instances of this class actually represents boxes.)

The SoCube node class is provided as a convenient abstraction for the application programmer to use 'complex' shapes of this type without having to do the calculation and book-keeping of the polygon sides and other low level programming herself.

FILE FORMAT/DEFAULTS:

Cube {
    width 2
    height 2
    depth 2
}

See also
    SoCylinder, SoSphere, SoCone

Constructor & Destructor Documentation

  SoCube::SoCube (void)
Constructor.

  SoCube::~SoCube () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoCube::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoCube::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoShape.

  const SoFieldData ** SoCube::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoCube::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoShape.

  void SoCube::initClass (void) [static]

  void SoCube::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

  void SoCube::rayPick (SoRayPickAction * action) [virtual]
Calculates picked point based on primitives generated by subclasses.

Reimplemented from SoShape.

  void SoCube::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

  void SoCube::generatePrimitives (SoAction * action) [protected], [virtual]
The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

  void SoCube::computeBBox (SoAction * action, SbBox3f & box, SbVec3f & center) [protected], [virtual]
Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

Member Data Documentation

  SoSFFloat SoCube::width
X-axis dimension of cube, defaults to 2.0.

  SoSFFloat SoCube::height
Y-axis dimension of cube, defaults to 2.0.

  SoSFFloat SoCube::depth
Z-axis dimension of cube, defaults to 2.0.

Author

Generated automatically by Doxygen for Coin from the source code.